local function drawText(text, x, y, scale, r, g, b)
	SetTextFont(0)
	SetTextCentre(1)
	SetTextProportional(0)
	SetTextScale(scale, scale)
	SetTextDropShadow(30, 5, 5, 5, 255)
	SetTextEntry("STRING")
	SetTextColour(r, g, b, 255)
	AddTextComponentString(text)
	DrawText(x, y)
end

local repairing = false

RegisterNetEvent("mechanic:repairClosestCar")
AddEventHandler("mechanic:repairClosestCar", function()

	if not repairing then

		local veh = 0
		local ped = PlayerPedId()

		if IsPedInAnyVehicle(ped, false) then
			veh = GetVehiclePedIsIn(ped, false)
		else
			veh = GetClosestVehicle(GetEntityCoords(ped), 10.0, 0, 4+2+1)
		end
		if veh ~= 0 then

			local waitTime = GetGameTimer() + 3000
			NetworkRequestControlOfEntity(veh)

			while not NetworkHasControlOfEntity(veh) and GetGameTimer() < waitTime do
				Citizen.Wait(10)
			end

			Citizen.CreateThread(function()
				repairing = true
				local minDimensions, maxDimensions = GetModelDimensions(GetEntityModel(veh))

				local hoodPos = GetOffsetFromEntityInWorldCoords(veh, 0.0, maxDimensions.y + 0.2, 0.0)
				local vehHeading = GetEntityHeading(veh)

				local dst = GetDistanceBetweenCoords(GetEntityCoords(ped), hoodPos, false)
				while dst < 15.0 and DoesEntityExist(veh) do

					DisableControlAction(0, 21, true)
					DisableControlAction(0, 22, true)

					DrawMarker(20, hoodPos, 0, 0, 0, 0, 0, 0, 0.301, 0.301, 0.3001, 66, 188, 245, 200, 0, 0, 0, 1)

					if dst <= 1.0 then
						drawText("Apasa ~b~[~w~E~b~]~w~ pentru a repara masina", 0.5, 0.85, 0.4, 255, 255, 255)
						if IsControlJustPressed(0, 38) then

							RequestAnimDict("anim@amb@clubhouse@tutorial@bkr_tut_ig3@")
							while not HasAnimDictLoaded("anim@amb@clubhouse@tutorial@bkr_tut_ig3@") do
								Citizen.Wait(1)
							end

							SetVehicleDoorOpen(veh, 4, false)
							Citizen.Wait(500)


							SetEntityCoords(ped, hoodPos - vector3(0.0, 0.0, maxDimensions.z))
							SetEntityHeading(ped, (vehHeading + 180) % 360)

							Citizen.Wait(300)

							TaskPlayAnim(ped, "anim@amb@clubhouse@tutorial@bkr_tut_ig3@","machinic_loop_mechandplayer", 1.5, 1.0, 0.3, 48, 0.2, 0, 0, 0)
							FreezeEntityPosition(ped, true)

							Citizen.CreateThread(function()
								local untilTime = GetGameTimer() + 3000

								while GetGameTimer() < untilTime do
									drawText("Ai inceput sa repari masina...", 0.5, 0.85, 0.4, 255, 255, 255)
									Citizen.Wait(1)
								end
							end)

							Citizen.Wait(13000)
							TriggerServerEvent("mechanic:useRepairKit")
							SetVehicleEngineHealth(veh, 1000.0)
							
							StopAnimTask(ped, "anim@amb@clubhouse@tutorial@bkr_tut_ig3@","machinic_loop_mechandplayer", 1.5)
							FreezeEntityPosition(ped, false)

							Citizen.Wait(500)
							SetVehicleDoorShut(veh, 4, false)

							Citizen.CreateThread(function()
								local untilTime = GetGameTimer() + 4000

								while GetGameTimer() < untilTime do
									drawText("Intra in masina pentru a verifica reparatia", 0.5, 0.85, 0.4, 255, 255, 255)
									Citizen.Wait(1)
								end
							end)

							local maxtime = GetGameTimer() + 30000
							while GetVehiclePedIsIn(ped, false) ~= veh and GetGameTimer() <= maxtime do
								Citizen.Wait(500)
							end

							Citizen.CreateThread(function()
								SetVehicleEngineHealth(veh, 1000.0)
								Citizen.Wait(500)
								SetVehicleEngineOn(veh, true, false, true)
							end)

							break

						end
					end

					dst = GetDistanceBetweenCoords(GetEntityCoords(ped), hoodPos, false)
					Citizen.Wait(1)
				end

				repairing = false
			end)
			
		else
			local untilTime = GetGameTimer() + 3000

			while GetGameTimer() < untilTime do
				drawText("Nu a fost gasita nici o masina in apropiere", 0.5, 0.85, 0.4, 255, 255, 252)
				Citizen.Wait(1)
			end
		end
	end
end)